/**
 * User: Elfrey
 * Date: 11.05.12
 */

var osmClass = function(params){
    this.map = {};
    this.marks = [];
    this.defaults = {
        mapSelector: "#map",
        flag: true,
        bgColor: "red",
        mapOptions: {
            scrollwheel: false,
            scaleControl: true,
            mapTypeControl: false
            //mapTypeControlOptions: {style: google.maps.MapTypeControlStyle.DROPDOWN_MENU}
        },
        position: {}
    };
    this.options = {};


    this.init(params);
};

osmClass.prototype.init = function(params){
    var __self = this,
        __self.options = $.extend({},__self.defaults,params),
        options = __self.options;
};

osmClass.prototype.reDraw = function(){
    var __self = this,
        options = __self.options;
};

$(function(){
    options = {
        mapSelector: "#map",
        flag: true,
        color: "red"
    }

    flag = true;

    windowInit("#map");
    $(window).resize(function(){
        windowInit("#map");
    });

    function windowInit(mapSelector){


        var $W = $(window),
            $D = $(document),
            wWidth = $W.width(),
            wHeight = $W.height();

        flag = (flag) ? false : true;

        color = (flag) ? "red" :  "blue";

        mapSelector = (mapSelector == undefined) ? "#map" : mapSelector;

        $(mapSelector).css({
            width: wWidth,
            height: wHeight,
            background: color
        });



        navigator.geolocation.getCurrentPosition(mapInit, onError);

        function mapInit(position) {

            // Задаем свойства карты и инициализируем ее

            var mapOptions = {
                scrollwheel: false,
                scaleControl: true,
                mapTypeControl: false
                //mapTypeControlOptions: {style: google.maps.MapTypeControlStyle.DROPDOWN_MENU}
            }

            var map = new google.maps.Map(document.getElementById("map"), mapOptions);
            map.setCenter(new google.maps.LatLng(position.coords.latitude,position.coords.longitude));
            map.setZoom(12);

            // Задаем слой с OSM

            var openStreet = new google.maps.ImageMapType({
                getTileUrl: function(ll, z) {
                    var X = ll.x % (1 << z);  // wrap
                    return "http://tile.openstreetmap.org/" + z + "/" + X + "/" + ll.y + ".png";
                },
                tileSize: new google.maps.Size(256, 256),
                isPng: true,
                maxZoom: 18,
                name: "OSM",
                alt: "Слой с Open Streetmap"
            });

            //Добавляем слои к карте

            map.mapTypes.set('osm', openStreet);
            map.setMapTypeId('osm');

            map.setOptions({
                mapTypeControlOptions: {
                    mapTypeIds: [
                        'osm',
                        google.maps.MapTypeId.ROADMAP,
                        google.maps.MapTypeId.TERRAIN,
                        google.maps.MapTypeId.SATELLITE,
                        google.maps.MapTypeId.HYBRID
                    ],
                    style: google.maps.MapTypeControlStyle.DROPDOWN_MENU
                }
            });

        }

        function onError(error){
            return false;//ВСЕ КОНЕЦ ЧТО ЖЕ ДЕЛАТЬ ЕПТА НАХ
        }
    }


});


function log(text){
    if ($("#log")){
        $("#log").append(text+"<br />");
    }
}